#ifndef _AUTO_REF_H_
#define _AUTO_REF_H_

template<class T>
class auto_ref{
	struct item_st{	
		int count;
		T obj;
	}*data_ref;
	void Free(item_st *ref) { 
		if(!ref) return;
		if(!--ref->count) delete ref;
	}
	void New() {		
		if(data_ref) return;
		data_ref=new item_st; 
		data_ref->count=1;
	}
public:
	auto_ref &operator =(auto_ref &obj) {
		item_st *temp=data_ref;
		data_ref=obj.data_ref;
		if(data_ref) data_ref->count++;
		Free(temp);
		return *this;
	}
	bool operator !=(auto_ref &obj) {
		return data_ref!=obj.data_ref;
	}
	auto_ref &operator =(const T &obj) {
		New();
		data_ref->obj=obj;
		return *this;
	}
	T *operator ->() { 
		New(); 
		return &data_ref->obj;
	}
	operator T&() {
		New();
		return data_ref->obj;
	}
	operator T*() {
		New();
		return &data_ref->obj;
	}
	auto_ref() { 
		data_ref=0;
	}
	auto_ref(auto_ref &obj) {
		operator=(obj);
	}
	~auto_ref() {
		Free(data_ref);
	}
};

#endif

